[clikt](../../index.md) / [com.github.ajalt.clikt.core](../index.md) / [NoRunCliktCommand](./index.md)

# NoRunCliktCommand

`open class NoRunCliktCommand : `[`CliktCommand`](../-clikt-command/index.md)

A [CliktCommand](../-clikt-command/index.md) that has a default implementation of [CliktCommand.run](../-clikt-command/run.md) that is a no-op.

### Constructors

| Name | Summary |
|---|---|
| [&lt;init&gt;](-init-.md) | `NoRunCliktCommand(help: `[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)` = "", epilog: `[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)` = "", name: `[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)`? = null, invokeWithoutSubcommand: `[`Boolean`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-boolean/index.html)` = false, printHelpOnEmptyArgs: `[`Boolean`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-boolean/index.html)` = false, helpTags: `[`Map`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin.collections/-map/index.html)`<`[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)`, `[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)`> = emptyMap(), autoCompleteEnvvar: `[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)`? = "")`<br>A [CliktCommand](../-clikt-command/index.md) that has a default implementation of [CliktCommand.run](../-clikt-command/run.md) that is a no-op. |

### Inherited Properties

| Name | Summary |
|---|---|
| [commandHelp](../-clikt-command/command-help.md) | `val commandHelp: `[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html) |
| [commandHelpEpilog](../-clikt-command/command-help-epilog.md) | `val commandHelpEpilog: `[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html) |
| [commandName](../-clikt-command/command-name.md) | `val commandName: `[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html) |
| [context](../-clikt-command/context.md) | `val context: `[`Context`](../-context/index.md)<br>This command's context. |
| [helpTags](../-clikt-command/help-tags.md) | `val helpTags: `[`Map`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin.collections/-map/index.html)`<`[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)`, `[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)`>`<br>Extra information about this option to pass to the help formatter. |
| [invokeWithoutSubcommand](../-clikt-command/invoke-without-subcommand.md) | `val invokeWithoutSubcommand: `[`Boolean`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-boolean/index.html)<br>Used when this command has subcommands, and this command is called without a subcommand. If true, [run](../-clikt-command/run.md) will be called. By default, a [PrintHelpMessage](../-print-help-message/index.md) is thrown instead. |
| [messages](../-clikt-command/messages.md) | `val messages: `[`List`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin.collections/-list/index.html)`<`[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)`>`<br>All messages issued during parsing. |
| [printHelpOnEmptyArgs](../-clikt-command/print-help-on-empty-args.md) | `val printHelpOnEmptyArgs: `[`Boolean`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-boolean/index.html)<br>If this command is called with no values on the command line, print a help message (by throwing [PrintHelpMessage](../-print-help-message/index.md)) if this is true, otherwise run normally. |

### Functions

| Name | Summary |
|---|---|
| [run](run.md) | `open fun run(): `[`Unit`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-unit/index.html)<br>Perform actions after parsing is complete and this command is invoked. |

### Inherited Functions

| Name | Summary |
|---|---|
| [aliases](../-clikt-command/aliases.md) | `open fun aliases(): `[`Map`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin.collections/-map/index.html)`<`[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)`, `[`List`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin.collections/-list/index.html)`<`[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)`>>`<br>A list of command aliases. |
| [echo](../-clikt-command/echo.md) | `fun echo(message: `[`Any`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-any/index.html)`?, trailingNewline: `[`Boolean`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-boolean/index.html)` = true, err: `[`Boolean`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-boolean/index.html)` = false, lineSeparator: `[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)` = context.console.lineSeparator): `[`Unit`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-unit/index.html)<br>Print the [message](../-clikt-command/echo.md#com.github.ajalt.clikt.core.CliktCommand$echo(kotlin.Any, kotlin.Boolean, kotlin.Boolean, kotlin.String)/message) to the screen. |
| [getFormattedHelp](../-clikt-command/get-formatted-help.md) | `open fun getFormattedHelp(): `[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)<br>Return the full help string for this command. |
| [getFormattedUsage](../-clikt-command/get-formatted-usage.md) | `open fun getFormattedUsage(): `[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)<br>Return the usage string for this command. |
| [issueMessage](../-clikt-command/issue-message.md) | `fun issueMessage(message: `[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)`): `[`Unit`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-unit/index.html)<br>Add a message to be printed after parsing |
| [main](../-clikt-command/main.md) | `fun main(argv: `[`List`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin.collections/-list/index.html)`<`[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)`>): `[`Unit`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-unit/index.html)<br>Parse the command line and print helpful output if any errors occur.`fun main(argv: `[`Array`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-array/index.html)`<`[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)`>): `[`Unit`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-unit/index.html) |
| [parse](../-clikt-command/parse.md) | `fun parse(argv: `[`List`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin.collections/-list/index.html)`<`[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)`>, parentContext: `[`Context`](../-context/index.md)`? = null): `[`Unit`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-unit/index.html)<br>Parse the command line and throw an exception if parsing fails.`fun parse(argv: `[`Array`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-array/index.html)`<`[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)`>, parentContext: `[`Context`](../-context/index.md)`? = null): `[`Unit`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-unit/index.html) |
| [registerArgument](../-clikt-command/register-argument.md) | `fun registerArgument(argument: `[`Argument`](../../com.github.ajalt.clikt.parameters.arguments/-argument/index.md)`): `[`Unit`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-unit/index.html)<br>Register an argument with this command. |
| [registeredSubcommandNames](../-clikt-command/registered-subcommand-names.md) | `fun registeredSubcommandNames(): `[`List`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin.collections/-list/index.html)`<`[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)`>`<br>The names of all direct children of this command |
| [registerOption](../-clikt-command/register-option.md) | `fun registerOption(option: `[`Option`](../../com.github.ajalt.clikt.parameters.options/-option/index.md)`): `[`Unit`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-unit/index.html)<br>Register an option with this command.`open fun registerOption(option: `[`GroupableOption`](../-groupable-option/index.md)`): `[`Unit`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-unit/index.html)<br>Register an option with this command or group. |
| [registerOptionGroup](../-clikt-command/register-option-group.md) | `fun registerOptionGroup(group: `[`ParameterGroup`](../../com.github.ajalt.clikt.parameters.groups/-parameter-group/index.md)`): `[`Unit`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-unit/index.html)<br>Register a group with this command. |
| [shortHelp](../-clikt-command/short-help.md) | `fun shortHelp(): `[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)<br>The help displayed in the commands list when this command is used as a subcommand. |

### Extension Functions

| Name | Summary |
|---|---|
| [argument](../../com.github.ajalt.clikt.parameters.arguments/argument.md) | `fun `[`CliktCommand`](../-clikt-command/index.md)`.argument(name: `[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)` = "", help: `[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)` = "", helpTags: `[`Map`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin.collections/-map/index.html)`<`[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)`, `[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)`> = emptyMap()): RawArgument`<br>Create a property delegate argument. |
| [context](../context.md) | `fun <T : `[`CliktCommand`](../-clikt-command/index.md)`> `[`T`](../context.md#T)`.context(block: `[`Context.Builder`](../-context/-builder/index.md)`.() -> `[`Unit`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-unit/index.html)`): `[`T`](../context.md#T)<br>Configure this command's [Context](../-context/index.md). |
| [findObject](../find-object.md) | `fun <T : `[`Any`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-any/index.html)`> `[`CliktCommand`](../-clikt-command/index.md)`.findObject(): `[`ReadOnlyProperty`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin.properties/-read-only-property/index.html)`<`[`CliktCommand`](../-clikt-command/index.md)`, `[`T`](../find-object.md#T)`?>`<br>Find the closest object of type [T](../find-object.md#T), or null`fun <T : `[`Any`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-any/index.html)`> `[`CliktCommand`](../-clikt-command/index.md)`.findObject(default: () -> `[`T`](../find-object.md#T)`): `[`ReadOnlyProperty`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin.properties/-read-only-property/index.html)`<`[`CliktCommand`](../-clikt-command/index.md)`, `[`T`](../find-object.md#T)`>`<br>Find the closest object of type [T](../find-object.md#T), setting `context.obj` if one is not found. |
| [mutuallyExclusiveOptions](../../com.github.ajalt.clikt.parameters.groups/mutually-exclusive-options.md) | `fun <T : `[`Any`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-any/index.html)`> `[`ParameterHolder`](../-parameter-holder/index.md)`.mutuallyExclusiveOptions(option1: `[`OptionDelegate`](../../com.github.ajalt.clikt.parameters.options/-option-delegate/index.md)`<`[`T`](../../com.github.ajalt.clikt.parameters.groups/mutually-exclusive-options.md#T)`?>, option2: `[`OptionDelegate`](../../com.github.ajalt.clikt.parameters.options/-option-delegate/index.md)`<`[`T`](../../com.github.ajalt.clikt.parameters.groups/mutually-exclusive-options.md#T)`?>, vararg options: `[`OptionDelegate`](../../com.github.ajalt.clikt.parameters.options/-option-delegate/index.md)`<`[`T`](../../com.github.ajalt.clikt.parameters.groups/mutually-exclusive-options.md#T)`?>, name: `[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)`? = null, help: `[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)`? = null): `[`MutuallyExclusiveOptions`](../../com.github.ajalt.clikt.parameters.groups/-mutually-exclusive-options/index.md)`<`[`T`](../../com.github.ajalt.clikt.parameters.groups/mutually-exclusive-options.md#T)`, `[`T`](../../com.github.ajalt.clikt.parameters.groups/mutually-exclusive-options.md#T)`?>`<br>Declare a set of two or more mutually exclusive options. |
| [option](../../com.github.ajalt.clikt.parameters.options/option.md) | `fun `[`ParameterHolder`](../-parameter-holder/index.md)`.option(vararg names: `[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)`, help: `[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)` = "", metavar: `[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)`? = null, hidden: `[`Boolean`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-boolean/index.html)` = false, envvar: `[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)`? = null, envvarSplit: `[`Regex`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin.text/-regex/index.html)`? = null, helpTags: `[`Map`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin.collections/-map/index.html)`<`[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)`, `[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)`> = emptyMap()): `[`RawOption`](../../com.github.ajalt.clikt.parameters.options/-raw-option.md)<br>Create a property delegate option. |
| [requireObject](../require-object.md) | `fun <T : `[`Any`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-any/index.html)`> `[`CliktCommand`](../-clikt-command/index.md)`.requireObject(): `[`ReadOnlyProperty`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin.properties/-read-only-property/index.html)`<`[`CliktCommand`](../-clikt-command/index.md)`, `[`T`](../require-object.md#T)`>`<br>Find the closest object of type [T](../require-object.md#T), or throw a [NullPointerException](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-null-pointer-exception/index.html) |
| [subcommands](../subcommands.md) | `fun <T : `[`CliktCommand`](../-clikt-command/index.md)`> `[`T`](../subcommands.md#T)`.subcommands(commands: `[`Iterable`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin.collections/-iterable/index.html)`<`[`CliktCommand`](../-clikt-command/index.md)`>): `[`T`](../subcommands.md#T)<br>`fun <T : `[`CliktCommand`](../-clikt-command/index.md)`> `[`T`](../subcommands.md#T)`.subcommands(vararg commands: `[`CliktCommand`](../-clikt-command/index.md)`): `[`T`](../subcommands.md#T)<br>Add the given commands as a subcommand of this command. |
| [versionOption](../../com.github.ajalt.clikt.parameters.options/version-option.md) | `fun <T : `[`CliktCommand`](../-clikt-command/index.md)`> `[`T`](../../com.github.ajalt.clikt.parameters.options/version-option.md#T)`.versionOption(version: `[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)`, help: `[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)` = "Show the version and exit", names: `[`Set`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin.collections/-set/index.html)`<`[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)`> = setOf("--version"), message: (`[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)`) -> `[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)` = { "$commandName version $it" }): `[`T`](../../com.github.ajalt.clikt.parameters.options/version-option.md#T)<br>Add an eager option to this command that, when invoked, prints a version message and exits. |
