[clikt](../index.md) / [com.github.ajalt.clikt.parameters.groups](./index.md)

## Package com.github.ajalt.clikt.parameters.groups

### Types

| Name | Summary |
|---|---|
| [ChoiceGroup](-choice-group/index.md) | `class ChoiceGroup<GroupT : `[`OptionGroup`](-option-group/index.md)`, OutT> : `[`ParameterGroupDelegate`](-parameter-group-delegate/index.md)`<`[`OutT`](-choice-group/index.md#OutT)`>` |
| [CoOccurringOptionGroup](-co-occurring-option-group/index.md) | `class CoOccurringOptionGroup<GroupT : `[`OptionGroup`](-option-group/index.md)`, OutT> : `[`ParameterGroupDelegate`](-parameter-group-delegate/index.md)`<`[`OutT`](-co-occurring-option-group/index.md#OutT)`>` |
| [MutuallyExclusiveOptions](-mutually-exclusive-options/index.md) | `class MutuallyExclusiveOptions<OptT : `[`Any`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-any/index.html)`, OutT> : `[`ParameterGroupDelegate`](-parameter-group-delegate/index.md)`<`[`OutT`](-mutually-exclusive-options/index.md#OutT)`>` |
| [OptionGroup](-option-group/index.md) | `open class OptionGroup : `[`ParameterGroup`](-parameter-group/index.md)`, `[`ParameterHolder`](../com.github.ajalt.clikt.core/-parameter-holder/index.md)<br>A group of options that can be shown together in help output, or restricted to be [cooccurring](cooccurring.md). |
| [ParameterGroup](-parameter-group/index.md) | `interface ParameterGroup` |
| [ParameterGroupDelegate](-parameter-group-delegate/index.md) | `interface ParameterGroupDelegate<out T> : `[`ParameterGroup`](-parameter-group/index.md)`, `[`ReadOnlyProperty`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin.properties/-read-only-property/index.html)`<`[`CliktCommand`](../com.github.ajalt.clikt.core/-clikt-command/index.md)`, `[`T`](-parameter-group-delegate/index.md#T)`>` |

### Functions

| Name | Summary |
|---|---|
| [cooccurring](cooccurring.md) | `fun <T : `[`OptionGroup`](-option-group/index.md)`> `[`T`](cooccurring.md#T)`.cooccurring(): `[`CoOccurringOptionGroup`](-co-occurring-option-group/index.md)`<`[`T`](cooccurring.md#T)`, `[`T`](cooccurring.md#T)`?>`<br>Make this group a co-occurring group. |
| [default](default.md) | `fun <T : `[`Any`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-any/index.html)`> `[`MutuallyExclusiveOptions`](-mutually-exclusive-options/index.md)`<`[`T`](default.md#T)`, `[`T`](default.md#T)`?>.default(value: `[`T`](default.md#T)`): `[`MutuallyExclusiveOptions`](-mutually-exclusive-options/index.md)`<`[`T`](default.md#T)`, `[`T`](default.md#T)`>`<br>If none of the options in a [mutuallyExclusiveOptions](mutually-exclusive-options.md) group are given on the command line, us [value](default.md#com.github.ajalt.clikt.parameters.groups$default(com.github.ajalt.clikt.parameters.groups.MutuallyExclusiveOptions((com.github.ajalt.clikt.parameters.groups.default.T, com.github.ajalt.clikt.parameters.groups.default.T)), com.github.ajalt.clikt.parameters.groups.default.T)/value) for the group. |
| [groupChoice](group-choice.md) | `fun <T : `[`OptionGroup`](-option-group/index.md)`> `[`RawOption`](../com.github.ajalt.clikt.parameters.options/-raw-option.md)`.groupChoice(choices: `[`Map`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin.collections/-map/index.html)`<`[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)`, `[`T`](group-choice.md#T)`>): `[`ChoiceGroup`](-choice-group/index.md)`<`[`T`](group-choice.md#T)`, `[`T`](group-choice.md#T)`?>`<br>`fun <T : `[`OptionGroup`](-option-group/index.md)`> `[`RawOption`](../com.github.ajalt.clikt.parameters.options/-raw-option.md)`.groupChoice(vararg choices: `[`Pair`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-pair/index.html)`<`[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)`, `[`T`](group-choice.md#T)`>): `[`ChoiceGroup`](-choice-group/index.md)`<`[`T`](group-choice.md#T)`, `[`T`](group-choice.md#T)`?>`<br>Convert the option to an option group based on a fixed set of values. |
| [mutuallyExclusiveOptions](mutually-exclusive-options.md) | `fun <T : `[`Any`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-any/index.html)`> `[`ParameterHolder`](../com.github.ajalt.clikt.core/-parameter-holder/index.md)`.mutuallyExclusiveOptions(option1: `[`OptionDelegate`](../com.github.ajalt.clikt.parameters.options/-option-delegate/index.md)`<`[`T`](mutually-exclusive-options.md#T)`?>, option2: `[`OptionDelegate`](../com.github.ajalt.clikt.parameters.options/-option-delegate/index.md)`<`[`T`](mutually-exclusive-options.md#T)`?>, vararg options: `[`OptionDelegate`](../com.github.ajalt.clikt.parameters.options/-option-delegate/index.md)`<`[`T`](mutually-exclusive-options.md#T)`?>, name: `[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)`? = null, help: `[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)`? = null): `[`MutuallyExclusiveOptions`](-mutually-exclusive-options/index.md)`<`[`T`](mutually-exclusive-options.md#T)`, `[`T`](mutually-exclusive-options.md#T)`?>`<br>Declare a set of two or more mutually exclusive options. |
| [provideDelegate](provide-delegate.md) | `operator fun <T : `[`OptionGroup`](-option-group/index.md)`> `[`T`](provide-delegate.md#T)`.provideDelegate(thisRef: `[`CliktCommand`](../com.github.ajalt.clikt.core/-clikt-command/index.md)`, prop: `[`KProperty`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin.reflect/-k-property/index.html)`<*>): `[`ReadOnlyProperty`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin.properties/-read-only-property/index.html)`<`[`CliktCommand`](../com.github.ajalt.clikt.core/-clikt-command/index.md)`, `[`T`](provide-delegate.md#T)`>` |
| [required](required.md) | `fun <T : `[`OptionGroup`](-option-group/index.md)`> `[`ChoiceGroup`](-choice-group/index.md)`<`[`T`](required.md#T)`, `[`T`](required.md#T)`?>.required(): `[`ChoiceGroup`](-choice-group/index.md)`<`[`T`](required.md#T)`, `[`T`](required.md#T)`>`<br>If a [groupChoice](group-choice.md) option is not called on the command line, throw a [MissingParameter](../com.github.ajalt.clikt.core/-missing-parameter/index.md) exception.`fun <T : `[`Any`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-any/index.html)`> `[`MutuallyExclusiveOptions`](-mutually-exclusive-options/index.md)`<`[`T`](required.md#T)`, `[`T`](required.md#T)`?>.required(): `[`MutuallyExclusiveOptions`](-mutually-exclusive-options/index.md)`<`[`T`](required.md#T)`, `[`T`](required.md#T)`>`<br>Make a [mutuallyExclusiveOptions](mutually-exclusive-options.md) group required. If none of the options in the group are given, a [UsageError](../com.github.ajalt.clikt.core/-usage-error/index.md) is thrown. |
| [single](single.md) | `fun <T : `[`Any`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-any/index.html)`> `[`MutuallyExclusiveOptions`](-mutually-exclusive-options/index.md)`<`[`T`](single.md#T)`, `[`T`](single.md#T)`?>.single(): `[`MutuallyExclusiveOptions`](-mutually-exclusive-options/index.md)`<`[`T`](single.md#T)`, `[`T`](single.md#T)`?>`<br>If more than one of the group's options are given on the command line, throw a [MutuallyExclusiveGroupException](../com.github.ajalt.clikt.core/-mutually-exclusive-group-exception/index.md) |
