[clikt](../../index.md) / [com.github.ajalt.clikt.parameters.arguments](../index.md) / [ProcessedArgument](./index.md)

# ProcessedArgument

`class ProcessedArgument<AllT, ValueT> : `[`ArgumentDelegate`](../-argument-delegate/index.md)`<`[`AllT`](index.md#AllT)`>`

An [Argument](../-argument/index.md) delegate implementation that transforms its values .

### Constructors

| Name | Summary |
|---|---|
| [&lt;init&gt;](-init-.md) | `ProcessedArgument(name: `[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)`, nvalues: `[`Int`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-int/index.html)`, required: `[`Boolean`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-boolean/index.html)`, help: `[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)`, helpTags: `[`Map`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin.collections/-map/index.html)`<`[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)`, `[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)`>, completionCandidates: `[`CompletionCandidates`](../../com.github.ajalt.clikt.completion/-completion-candidates/index.md)`, transformValue: `[`ArgValueTransformer`](../-arg-value-transformer.md)`<`[`ValueT`](index.md#ValueT)`>, transformAll: `[`ArgCallsTransformer`](../-arg-calls-transformer.md)`<`[`AllT`](index.md#AllT)`, `[`ValueT`](index.md#ValueT)`>, transformValidator: `[`ArgValidator`](../-arg-validator.md)`<`[`AllT`](index.md#AllT)`>)`<br>An [Argument](../-argument/index.md) delegate implementation that transforms its values . |

### Properties

| Name | Summary |
|---|---|
| [completionCandidates](completion-candidates.md) | `val completionCandidates: `[`CompletionCandidates`](../../com.github.ajalt.clikt.completion/-completion-candidates/index.md)<br>Optional set of strings to use when the user invokes shell autocomplete on a value for this argument. |
| [help](help.md) | `val help: `[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)<br>The description of this argument. |
| [helpTags](help-tags.md) | `val helpTags: `[`Map`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin.collections/-map/index.html)`<`[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)`, `[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)`>`<br>Extra information about this argument to pass to the help formatter. |
| [name](name.md) | `var name: `[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)<br>The metavar for this argument. |
| [nvalues](nvalues.md) | `val nvalues: `[`Int`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-int/index.html)<br>The number of values that this argument takes. |
| [parameterHelp](parameter-help.md) | `val parameterHelp: `[`HelpFormatter.ParameterHelp.Argument`](../../com.github.ajalt.clikt.output/-help-formatter/-parameter-help/-argument/index.md)<br>Information about this argument for the help output. |
| [required](required.md) | `val required: `[`Boolean`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-boolean/index.html)<br>If true, an error will be thrown if this argument is not given on the command line. |
| [transformAll](transform-all.md) | `val transformAll: `[`ArgCallsTransformer`](../-arg-calls-transformer.md)`<`[`AllT`](index.md#AllT)`, `[`ValueT`](index.md#ValueT)`>`<br>Called in [finalize](finalize.md) to transform the list of values to the final type. |
| [transformValidator](transform-validator.md) | `val transformValidator: `[`ArgValidator`](../-arg-validator.md)`<`[`AllT`](index.md#AllT)`>`<br>Called after all paramters have been [finalize](finalize.md)d to validate the result of [transformAll](transform-all.md) |
| [transformValue](transform-value.md) | `val transformValue: `[`ArgValueTransformer`](../-arg-value-transformer.md)`<`[`ValueT`](index.md#ValueT)`>`<br>Called in [finalize](finalize.md) to transform each value provided to the argument. |

### Functions

| Name | Summary |
|---|---|
| [copy](copy.md) | `fun <AllT, ValueT> copy(transformValue: `[`ArgValueTransformer`](../-arg-value-transformer.md)`<`[`ValueT`](copy.md#ValueT)`>, transformAll: `[`ArgCallsTransformer`](../-arg-calls-transformer.md)`<`[`AllT`](copy.md#AllT)`, `[`ValueT`](copy.md#ValueT)`>, validator: `[`ArgValidator`](../-arg-validator.md)`<`[`AllT`](copy.md#AllT)`>, name: `[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)` = this.name, nvalues: `[`Int`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-int/index.html)` = this.nvalues, required: `[`Boolean`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-boolean/index.html)` = this.required, help: `[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)` = this.help, helpTags: `[`Map`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin.collections/-map/index.html)`<`[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)`, `[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)`> = this.helpTags, completionCandidates: `[`CompletionCandidates`](../../com.github.ajalt.clikt.completion/-completion-candidates/index.md)` = this.completionCandidates): `[`ProcessedArgument`](./index.md)`<`[`AllT`](copy.md#AllT)`, `[`ValueT`](copy.md#ValueT)`>`<br>Create a new argument that is a copy of this one with different transforms.`fun copy(validator: `[`ArgValidator`](../-arg-validator.md)`<`[`AllT`](index.md#AllT)`> = this.transformValidator, name: `[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)` = this.name, nvalues: `[`Int`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-int/index.html)` = this.nvalues, required: `[`Boolean`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-boolean/index.html)` = this.required, help: `[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)` = this.help, helpTags: `[`Map`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin.collections/-map/index.html)`<`[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)`, `[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)`> = this.helpTags, completionCandidates: `[`CompletionCandidates`](../../com.github.ajalt.clikt.completion/-completion-candidates/index.md)` = this.completionCandidates): `[`ProcessedArgument`](./index.md)`<`[`AllT`](index.md#AllT)`, `[`ValueT`](index.md#ValueT)`>`<br>Create a new argument that is a copy of this one with the same transforms. |
| [finalize](finalize.md) | `fun finalize(context: `[`Context`](../../com.github.ajalt.clikt.core/-context/index.md)`, values: `[`List`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin.collections/-list/index.html)`<`[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)`>): `[`Unit`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-unit/index.html)<br>Called after this command's argv is parsed to transform and store the argument's value. |
| [getValue](get-value.md) | `fun getValue(thisRef: `[`CliktCommand`](../../com.github.ajalt.clikt.core/-clikt-command/index.md)`, property: `[`KProperty`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin.reflect/-k-property/index.html)`<*>): `[`AllT`](index.md#AllT) |
| [postValidate](post-validate.md) | `fun postValidate(context: `[`Context`](../../com.github.ajalt.clikt.core/-context/index.md)`): `[`Unit`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-unit/index.html)<br>Called after all of a command's parameters have been [finalize](../-argument/finalize.md)d to perform validation of the final value. |
| [provideDelegate](provide-delegate.md) | `operator fun provideDelegate(thisRef: `[`CliktCommand`](../../com.github.ajalt.clikt.core/-clikt-command/index.md)`, prop: `[`KProperty`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin.reflect/-k-property/index.html)`<*>): `[`ReadOnlyProperty`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin.properties/-read-only-property/index.html)`<`[`CliktCommand`](../../com.github.ajalt.clikt.core/-clikt-command/index.md)`, `[`AllT`](index.md#AllT)`>`<br>Implementations must call [CliktCommand.registerArgument](../../com.github.ajalt.clikt.core/-clikt-command/register-argument.md) |

### Extension Functions

| Name | Summary |
|---|---|
| [choice](../../com.github.ajalt.clikt.parameters.types/choice.md) | `fun <T : `[`Any`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-any/index.html)`> RawArgument.choice(choices: `[`Map`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin.collections/-map/index.html)`<`[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)`, `[`T`](../../com.github.ajalt.clikt.parameters.types/choice.md#T)`>): `[`ProcessedArgument`](./index.md)`<`[`T`](../../com.github.ajalt.clikt.parameters.types/choice.md#T)`, `[`T`](../../com.github.ajalt.clikt.parameters.types/choice.md#T)`>`<br>`fun <T : `[`Any`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-any/index.html)`> RawArgument.choice(vararg choices: `[`Pair`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-pair/index.html)`<`[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)`, `[`T`](../../com.github.ajalt.clikt.parameters.types/choice.md#T)`>): `[`ProcessedArgument`](./index.md)`<`[`T`](../../com.github.ajalt.clikt.parameters.types/choice.md#T)`, `[`T`](../../com.github.ajalt.clikt.parameters.types/choice.md#T)`>`<br>Convert the argument based on a fixed set of values.`fun RawArgument.choice(vararg choices: `[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)`): `[`ProcessedArgument`](./index.md)`<`[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)`, `[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)`>`<br>Restrict the argument to a fixed set of values. |
| [convert](../convert.md) | `fun <T : `[`Any`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-any/index.html)`> RawArgument.convert(completionCandidates: `[`CompletionCandidates`](../../com.github.ajalt.clikt.completion/-completion-candidates/index.md)` = this.completionCandidates, conversion: `[`ArgValueTransformer`](../-arg-value-transformer.md)`<`[`T`](../convert.md#T)`>): `[`ProcessedArgument`](./index.md)`<`[`T`](../convert.md#T)`, `[`T`](../convert.md#T)`>`<br>Convert the argument's values. |
| [default](../default.md) | `fun <T : `[`Any`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-any/index.html)`> `[`ProcessedArgument`](./index.md)`<`[`T`](../default.md#T)`, `[`T`](../default.md#T)`>.default(value: `[`T`](../default.md#T)`): `[`ArgumentDelegate`](../-argument-delegate/index.md)`<`[`T`](../default.md#T)`>`<br>If the argument is not given, use [value](../default.md#com.github.ajalt.clikt.parameters.arguments$default(com.github.ajalt.clikt.parameters.arguments.ProcessedArgument((com.github.ajalt.clikt.parameters.arguments.default.T, )), com.github.ajalt.clikt.parameters.arguments.default.T)/value) instead of throwing an error. |
| [defaultLazy](../default-lazy.md) | `fun <T : `[`Any`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-any/index.html)`> `[`ProcessedArgument`](./index.md)`<`[`T`](../default-lazy.md#T)`, `[`T`](../default-lazy.md#T)`>.defaultLazy(value: () -> `[`T`](../default-lazy.md#T)`): `[`ArgumentDelegate`](../-argument-delegate/index.md)`<`[`T`](../default-lazy.md#T)`>`<br>If the argument is not given, call [value](../default-lazy.md#com.github.ajalt.clikt.parameters.arguments$defaultLazy(com.github.ajalt.clikt.parameters.arguments.ProcessedArgument((com.github.ajalt.clikt.parameters.arguments.defaultLazy.T, )), kotlin.Function0((com.github.ajalt.clikt.parameters.arguments.defaultLazy.T)))/value) and use its return value instead of throwing an error. |
| [double](../../com.github.ajalt.clikt.parameters.types/double.md) | `fun RawArgument.double(): `[`ProcessedArgument`](./index.md)`<`[`Double`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-double/index.html)`, `[`Double`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-double/index.html)`>`<br>Convert the argument values to a `Double` |
| [file](../../com.github.ajalt.clikt.parameters.types/file.md) | `fun RawArgument.file(exists: `[`Boolean`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-boolean/index.html)` = false, fileOkay: `[`Boolean`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-boolean/index.html)` = true, folderOkay: `[`Boolean`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-boolean/index.html)` = true, writable: `[`Boolean`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-boolean/index.html)` = false, readable: `[`Boolean`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-boolean/index.html)` = false): `[`ProcessedArgument`](./index.md)`<`[`File`](https://docs.oracle.com/javase/6/docs/api/java/io/File.html)`, `[`File`](https://docs.oracle.com/javase/6/docs/api/java/io/File.html)`>`<br>Convert the argument to a [File](https://docs.oracle.com/javase/6/docs/api/java/io/File.html). |
| [float](../../com.github.ajalt.clikt.parameters.types/float.md) | `fun RawArgument.float(): `[`ProcessedArgument`](./index.md)`<`[`Float`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-float/index.html)`, `[`Float`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-float/index.html)`>`<br>Convert the argument values to a `Float` |
| [int](../../com.github.ajalt.clikt.parameters.types/int.md) | `fun RawArgument.int(): `[`ProcessedArgument`](./index.md)`<`[`Int`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-int/index.html)`, `[`Int`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-int/index.html)`>`<br>Convert the argument values to an `Int` |
| [long](../../com.github.ajalt.clikt.parameters.types/long.md) | `fun RawArgument.long(): `[`ProcessedArgument`](./index.md)`<`[`Long`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-long/index.html)`, `[`Long`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-long/index.html)`>`<br>Convert the argument values to a `Long` |
| [multiple](../multiple.md) | `fun <T : `[`Any`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-any/index.html)`> `[`ProcessedArgument`](./index.md)`<`[`T`](../multiple.md#T)`, `[`T`](../multiple.md#T)`>.multiple(required: `[`Boolean`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-boolean/index.html)` = false): `[`ProcessedArgument`](./index.md)`<`[`List`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin.collections/-list/index.html)`<`[`T`](../multiple.md#T)`>, `[`T`](../multiple.md#T)`>`<br>Accept any number of values to this argument. |
| [optional](../optional.md) | `fun <AllT : `[`Any`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-any/index.html)`, ValueT> `[`ProcessedArgument`](./index.md)`<`[`AllT`](../optional.md#AllT)`, `[`ValueT`](../optional.md#ValueT)`>.optional(): `[`ProcessedArgument`](./index.md)`<`[`AllT`](../optional.md#AllT)`?, `[`ValueT`](../optional.md#ValueT)`>`<br>Return null instead of throwing an error if no value is given. |
| [pair](../pair.md) | `fun <T : `[`Any`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-any/index.html)`> `[`ProcessedArgument`](./index.md)`<`[`T`](../pair.md#T)`, `[`T`](../pair.md#T)`>.pair(): `[`ProcessedArgument`](./index.md)`<`[`Pair`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-pair/index.html)`<`[`T`](../pair.md#T)`, `[`T`](../pair.md#T)`>, `[`T`](../pair.md#T)`>`<br>Require exactly two values to this argument, and store them in a [Pair](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-pair/index.html). |
| [path](../../com.github.ajalt.clikt.parameters.types/path.md) | `fun RawArgument.path(exists: `[`Boolean`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-boolean/index.html)` = false, fileOkay: `[`Boolean`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-boolean/index.html)` = true, folderOkay: `[`Boolean`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-boolean/index.html)` = true, writable: `[`Boolean`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-boolean/index.html)` = false, readable: `[`Boolean`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-boolean/index.html)` = false, fileSystem: FileSystem = FileSystems.getDefault()): `[`ProcessedArgument`](./index.md)`<Path, Path>`<br>Convert the argument to a [Path](#). |
| [restrictTo](../../com.github.ajalt.clikt.parameters.types/restrict-to.md) | `fun <T> `[`ProcessedArgument`](./index.md)`<`[`T`](../../com.github.ajalt.clikt.parameters.types/restrict-to.md#T)`, `[`T`](../../com.github.ajalt.clikt.parameters.types/restrict-to.md#T)`>.restrictTo(min: `[`T`](../../com.github.ajalt.clikt.parameters.types/restrict-to.md#T)`? = null, max: `[`T`](../../com.github.ajalt.clikt.parameters.types/restrict-to.md#T)`? = null, clamp: `[`Boolean`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-boolean/index.html)` = false): `[`ProcessedArgument`](./index.md)`<`[`T`](../../com.github.ajalt.clikt.parameters.types/restrict-to.md#T)`, `[`T`](../../com.github.ajalt.clikt.parameters.types/restrict-to.md#T)`> where T : `[`Number`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-number/index.html)`, T : `[`Comparable`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-comparable/index.html)`<`[`T`](../../com.github.ajalt.clikt.parameters.types/restrict-to.md#T)`>`<br>`fun <T> `[`ProcessedArgument`](./index.md)`<`[`T`](../../com.github.ajalt.clikt.parameters.types/restrict-to.md#T)`, `[`T`](../../com.github.ajalt.clikt.parameters.types/restrict-to.md#T)`>.restrictTo(range: `[`ClosedRange`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin.ranges/-closed-range/index.html)`<`[`T`](../../com.github.ajalt.clikt.parameters.types/restrict-to.md#T)`>, clamp: `[`Boolean`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-boolean/index.html)` = false): `[`ProcessedArgument`](./index.md)`<`[`T`](../../com.github.ajalt.clikt.parameters.types/restrict-to.md#T)`, `[`T`](../../com.github.ajalt.clikt.parameters.types/restrict-to.md#T)`> where T : `[`Number`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-number/index.html)`, T : `[`Comparable`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-comparable/index.html)`<`[`T`](../../com.github.ajalt.clikt.parameters.types/restrict-to.md#T)`>`<br>Restrict the argument values to fit into a range. |
| [transformAll](../transform-all.md) | `fun <AllInT, ValueT, AllOutT> `[`ProcessedArgument`](./index.md)`<`[`AllInT`](../transform-all.md#AllInT)`, `[`ValueT`](../transform-all.md#ValueT)`>.transformAll(nvalues: `[`Int`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-int/index.html)`? = null, required: `[`Boolean`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-boolean/index.html)`? = null, transform: `[`ArgCallsTransformer`](../-arg-calls-transformer.md)`<`[`AllOutT`](../transform-all.md#AllOutT)`, `[`ValueT`](../transform-all.md#ValueT)`>): `[`ProcessedArgument`](./index.md)`<`[`AllOutT`](../transform-all.md#AllOutT)`, `[`ValueT`](../transform-all.md#ValueT)`>`<br>Transform all values to the final argument type. |
| [triple](../triple.md) | `fun <T : `[`Any`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-any/index.html)`> `[`ProcessedArgument`](./index.md)`<`[`T`](../triple.md#T)`, `[`T`](../triple.md#T)`>.triple(): `[`ProcessedArgument`](./index.md)`<`[`Triple`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-triple/index.html)`<`[`T`](../triple.md#T)`, `[`T`](../triple.md#T)`, `[`T`](../triple.md#T)`>, `[`T`](../triple.md#T)`>`<br>Require exactly three values to this argument, and store them in a [Triple](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-triple/index.html) |
| [unique](../unique.md) | `fun <T : `[`Any`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-any/index.html)`> `[`ProcessedArgument`](./index.md)`<`[`List`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin.collections/-list/index.html)`<`[`T`](../unique.md#T)`>, `[`T`](../unique.md#T)`>.unique(): `[`ProcessedArgument`](./index.md)`<`[`Set`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin.collections/-set/index.html)`<`[`T`](../unique.md#T)`>, `[`T`](../unique.md#T)`>`<br>Only store unique values for this argument |
| [validate](../validate.md) | `fun <AllT : `[`Any`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-any/index.html)`, ValueT> `[`ProcessedArgument`](./index.md)`<`[`AllT`](../validate.md#AllT)`, `[`ValueT`](../validate.md#ValueT)`>.validate(validator: `[`ArgValidator`](../-arg-validator.md)`<`[`AllT`](../validate.md#AllT)`>): `[`ArgumentDelegate`](../-argument-delegate/index.md)`<`[`AllT`](../validate.md#AllT)`>`<br>Check the final argument value and raise an error if it's not valid. |
