[clikt](../index.md) / [com.github.ajalt.clikt.parameters.types](./index.md)

## Package com.github.ajalt.clikt.parameters.types

### Functions

| Name | Summary |
|---|---|
| [choice](choice.md) | `fun <T : `[`Any`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-any/index.html)`> RawArgument.choice(choices: `[`Map`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin.collections/-map/index.html)`<`[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)`, `[`T`](choice.md#T)`>): `[`ProcessedArgument`](../com.github.ajalt.clikt.parameters.arguments/-processed-argument/index.md)`<`[`T`](choice.md#T)`, `[`T`](choice.md#T)`>`<br>`fun <T : `[`Any`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-any/index.html)`> RawArgument.choice(vararg choices: `[`Pair`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-pair/index.html)`<`[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)`, `[`T`](choice.md#T)`>): `[`ProcessedArgument`](../com.github.ajalt.clikt.parameters.arguments/-processed-argument/index.md)`<`[`T`](choice.md#T)`, `[`T`](choice.md#T)`>`<br>Convert the argument based on a fixed set of values.`fun RawArgument.choice(vararg choices: `[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)`): `[`ProcessedArgument`](../com.github.ajalt.clikt.parameters.arguments/-processed-argument/index.md)`<`[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)`, `[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)`>`<br>Restrict the argument to a fixed set of values.`fun <T : `[`Any`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-any/index.html)`> `[`RawOption`](../com.github.ajalt.clikt.parameters.options/-raw-option.md)`.choice(choices: `[`Map`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin.collections/-map/index.html)`<`[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)`, `[`T`](choice.md#T)`>, metavar: `[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)` = mvar(choices.keys)): `[`NullableOption`](../com.github.ajalt.clikt.parameters.options/-nullable-option.md)`<`[`T`](choice.md#T)`, `[`T`](choice.md#T)`>`<br>`fun <T : `[`Any`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-any/index.html)`> `[`RawOption`](../com.github.ajalt.clikt.parameters.options/-raw-option.md)`.choice(vararg choices: `[`Pair`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-pair/index.html)`<`[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)`, `[`T`](choice.md#T)`>, metavar: `[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)` = mvar(choices.map { it.first })): `[`NullableOption`](../com.github.ajalt.clikt.parameters.options/-nullable-option.md)`<`[`T`](choice.md#T)`, `[`T`](choice.md#T)`>`<br>Convert the option based on a fixed set of values.`fun `[`RawOption`](../com.github.ajalt.clikt.parameters.options/-raw-option.md)`.choice(vararg choices: `[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)`, metavar: `[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)` = mvar(choices.asIterable())): `[`NullableOption`](../com.github.ajalt.clikt.parameters.options/-nullable-option.md)`<`[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)`, `[`String`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-string/index.html)`>`<br>Restrict the option to a fixed set of values. |
| [double](double.md) | `fun RawArgument.double(): `[`ProcessedArgument`](../com.github.ajalt.clikt.parameters.arguments/-processed-argument/index.md)`<`[`Double`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-double/index.html)`, `[`Double`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-double/index.html)`>`<br>Convert the argument values to a `Double``fun `[`RawOption`](../com.github.ajalt.clikt.parameters.options/-raw-option.md)`.double(): `[`NullableOption`](../com.github.ajalt.clikt.parameters.options/-nullable-option.md)`<`[`Double`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-double/index.html)`, `[`Double`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-double/index.html)`>`<br>Convert the option values to a `Double` |
| [file](file.md) | `fun RawArgument.file(exists: `[`Boolean`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-boolean/index.html)` = false, fileOkay: `[`Boolean`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-boolean/index.html)` = true, folderOkay: `[`Boolean`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-boolean/index.html)` = true, writable: `[`Boolean`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-boolean/index.html)` = false, readable: `[`Boolean`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-boolean/index.html)` = false): `[`ProcessedArgument`](../com.github.ajalt.clikt.parameters.arguments/-processed-argument/index.md)`<`[`File`](https://docs.oracle.com/javase/6/docs/api/java/io/File.html)`, `[`File`](https://docs.oracle.com/javase/6/docs/api/java/io/File.html)`>`<br>Convert the argument to a [File](https://docs.oracle.com/javase/6/docs/api/java/io/File.html).`fun `[`RawOption`](../com.github.ajalt.clikt.parameters.options/-raw-option.md)`.file(exists: `[`Boolean`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-boolean/index.html)` = false, fileOkay: `[`Boolean`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-boolean/index.html)` = true, folderOkay: `[`Boolean`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-boolean/index.html)` = true, writable: `[`Boolean`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-boolean/index.html)` = false, readable: `[`Boolean`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-boolean/index.html)` = false): `[`NullableOption`](../com.github.ajalt.clikt.parameters.options/-nullable-option.md)`<`[`File`](https://docs.oracle.com/javase/6/docs/api/java/io/File.html)`, `[`File`](https://docs.oracle.com/javase/6/docs/api/java/io/File.html)`>`<br>Convert the option to a [File](https://docs.oracle.com/javase/6/docs/api/java/io/File.html). |
| [float](float.md) | `fun RawArgument.float(): `[`ProcessedArgument`](../com.github.ajalt.clikt.parameters.arguments/-processed-argument/index.md)`<`[`Float`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-float/index.html)`, `[`Float`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-float/index.html)`>`<br>Convert the argument values to a `Float``fun `[`RawOption`](../com.github.ajalt.clikt.parameters.options/-raw-option.md)`.float(): `[`NullableOption`](../com.github.ajalt.clikt.parameters.options/-nullable-option.md)`<`[`Float`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-float/index.html)`, `[`Float`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-float/index.html)`>`<br>Convert the option values to a `Float` |
| [int](int.md) | `fun RawArgument.int(): `[`ProcessedArgument`](../com.github.ajalt.clikt.parameters.arguments/-processed-argument/index.md)`<`[`Int`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-int/index.html)`, `[`Int`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-int/index.html)`>`<br>Convert the argument values to an `Int``fun `[`RawOption`](../com.github.ajalt.clikt.parameters.options/-raw-option.md)`.int(): `[`NullableOption`](../com.github.ajalt.clikt.parameters.options/-nullable-option.md)`<`[`Int`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-int/index.html)`, `[`Int`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-int/index.html)`>`<br>Convert the option values to an `Int` |
| [long](long.md) | `fun RawArgument.long(): `[`ProcessedArgument`](../com.github.ajalt.clikt.parameters.arguments/-processed-argument/index.md)`<`[`Long`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-long/index.html)`, `[`Long`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-long/index.html)`>`<br>Convert the argument values to a `Long``fun `[`RawOption`](../com.github.ajalt.clikt.parameters.options/-raw-option.md)`.long(): `[`NullableOption`](../com.github.ajalt.clikt.parameters.options/-nullable-option.md)`<`[`Long`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-long/index.html)`, `[`Long`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-long/index.html)`>`<br>Convert the option values to a `Long` |
| [path](path.md) | `fun RawArgument.path(exists: `[`Boolean`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-boolean/index.html)` = false, fileOkay: `[`Boolean`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-boolean/index.html)` = true, folderOkay: `[`Boolean`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-boolean/index.html)` = true, writable: `[`Boolean`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-boolean/index.html)` = false, readable: `[`Boolean`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-boolean/index.html)` = false, fileSystem: FileSystem = FileSystems.getDefault()): `[`ProcessedArgument`](../com.github.ajalt.clikt.parameters.arguments/-processed-argument/index.md)`<Path, Path>`<br>Convert the argument to a [Path](#).`fun `[`RawOption`](../com.github.ajalt.clikt.parameters.options/-raw-option.md)`.path(exists: `[`Boolean`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-boolean/index.html)` = false, fileOkay: `[`Boolean`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-boolean/index.html)` = true, folderOkay: `[`Boolean`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-boolean/index.html)` = true, writable: `[`Boolean`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-boolean/index.html)` = false, readable: `[`Boolean`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-boolean/index.html)` = false, fileSystem: FileSystem = FileSystems.getDefault()): `[`NullableOption`](../com.github.ajalt.clikt.parameters.options/-nullable-option.md)`<Path, Path>`<br>Convert the option to a [Path](#). |
| [restrictTo](restrict-to.md) | `fun <T> `[`ProcessedArgument`](../com.github.ajalt.clikt.parameters.arguments/-processed-argument/index.md)`<`[`T`](restrict-to.md#T)`, `[`T`](restrict-to.md#T)`>.restrictTo(min: `[`T`](restrict-to.md#T)`? = null, max: `[`T`](restrict-to.md#T)`? = null, clamp: `[`Boolean`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-boolean/index.html)` = false): `[`ProcessedArgument`](../com.github.ajalt.clikt.parameters.arguments/-processed-argument/index.md)`<`[`T`](restrict-to.md#T)`, `[`T`](restrict-to.md#T)`> where T : `[`Number`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-number/index.html)`, T : `[`Comparable`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-comparable/index.html)`<`[`T`](restrict-to.md#T)`>`<br>`fun <T> `[`ProcessedArgument`](../com.github.ajalt.clikt.parameters.arguments/-processed-argument/index.md)`<`[`T`](restrict-to.md#T)`, `[`T`](restrict-to.md#T)`>.restrictTo(range: `[`ClosedRange`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin.ranges/-closed-range/index.html)`<`[`T`](restrict-to.md#T)`>, clamp: `[`Boolean`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-boolean/index.html)` = false): `[`ProcessedArgument`](../com.github.ajalt.clikt.parameters.arguments/-processed-argument/index.md)`<`[`T`](restrict-to.md#T)`, `[`T`](restrict-to.md#T)`> where T : `[`Number`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-number/index.html)`, T : `[`Comparable`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-comparable/index.html)`<`[`T`](restrict-to.md#T)`>`<br>Restrict the argument values to fit into a range.`fun <T> `[`OptionWithValues`](../com.github.ajalt.clikt.parameters.options/-option-with-values/index.md)`<`[`T`](restrict-to.md#T)`?, `[`T`](restrict-to.md#T)`, `[`T`](restrict-to.md#T)`>.restrictTo(min: `[`T`](restrict-to.md#T)`? = null, max: `[`T`](restrict-to.md#T)`? = null, clamp: `[`Boolean`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-boolean/index.html)` = false): `[`OptionWithValues`](../com.github.ajalt.clikt.parameters.options/-option-with-values/index.md)`<`[`T`](restrict-to.md#T)`?, `[`T`](restrict-to.md#T)`, `[`T`](restrict-to.md#T)`> where T : `[`Number`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-number/index.html)`, T : `[`Comparable`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-comparable/index.html)`<`[`T`](restrict-to.md#T)`>`<br>`fun <T> `[`OptionWithValues`](../com.github.ajalt.clikt.parameters.options/-option-with-values/index.md)`<`[`T`](restrict-to.md#T)`?, `[`T`](restrict-to.md#T)`, `[`T`](restrict-to.md#T)`>.restrictTo(range: `[`ClosedRange`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin.ranges/-closed-range/index.html)`<`[`T`](restrict-to.md#T)`>, clamp: `[`Boolean`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-boolean/index.html)` = false): `[`OptionWithValues`](../com.github.ajalt.clikt.parameters.options/-option-with-values/index.md)`<`[`T`](restrict-to.md#T)`?, `[`T`](restrict-to.md#T)`, `[`T`](restrict-to.md#T)`> where T : `[`Number`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-number/index.html)`, T : `[`Comparable`](https://kotlinlang.org/api/latest/jvm/stdlib/kotlin/-comparable/index.html)`<`[`T`](restrict-to.md#T)`>`<br>Restrict the option values to fit into a range. |
